

from datetime import datetime, timedelta
from app import db
from app.models import LoginAttempt, IPBan

def add_login_attempt(ip_address, is_successful):
    attempt = LoginAttempt(ip_address=ip_address, is_successful=is_successful)
    db.session.add(attempt)
    db.session.commit()

def check_and_ban_ip(ip_address):
    recent_attempts = LoginAttempt.query.filter_by(ip_address=ip_address, is_successful=False)\
        .filter(LoginAttempt.timestamp > datetime.utcnow() - timedelta(minutes=0)).count()
    
    if recent_attempts >= 5:
        ban = IPBan(ip_address=ip_address, ban_end=datetime.utcnow() + timedelta(minutes=0))
        db.session.add(ban)
        db.session.commit()
        return True
    return False

def is_ip_banned(ip_address):
    ban = IPBan.query.filter_by(ip_address=ip_address)\
        .filter(IPBan.ban_end > datetime.utcnow()).first()
    return ban is not None
